!function($, window, document, _undefined)
{
    "use strict";

    XF.DataFetcher = XF.Element.newHandler({

        options: {
            actionButton: '.js-fetchAction'
        },

        init: function()
        {
            var self = this,
                options = this.options,
                $target = this.$target;

            $target.on('click', options.actionButton, XF.proxy(this, 'actionButtonClick'));
        },

        actionButtonClick: function(e)
        {
            e.preventDefault();
            this.response();
        },

        response: function()
        {
            if (this.xhr)
            {
                this.xhr.abort();
            }

            var $url = this.$target.find('#ldUrl');
            this.xhr = XF.ajax('post', XF.canonicalizeUrl('index.php?link-directory/pagedata'), { url: $url.val() }, XF.proxy(this, 'complete'));
        },

        complete: function(data)
        {
            this.xhr = null;

            if(!data.title && !data.description)
            {
                var title = XF.phrase('oops_we_ran_into_some_problems');
                var msg1 = '<li>' + XF.phrase('ld_no_data_received') + '</li>';
                var msg2 = '';

                if(data.status_code >= 400)
                {
                    msg2 = '<li>' + XF.phrase('ld_status_code: ') + data.status_code + '</li>';
                }

                var messageHtml = '<div class="blockMessage"><ul>' + msg1 + msg2 + '</ul></div>';
                XF.overlayMessage(title, messageHtml);
            }
            else
            {
                if(data.title)
                {
                    this.$target.find('.ldTitle').val(data.title);
                }

                if(data.description)
                {
                    this.$target.find('.ldDescription').val(data.description);
                }
            }
        }
    });


    XF.Element.register('ld-data-fetcher', 'XF.DataFetcher');
}(jQuery, window, document);