<?php

namespace xenMade\LD\ApprovalQueue;

use XF\ApprovalQueue\AbstractHandler;
use XF\Mvc\Entity\Entity;

class Link extends AbstractHandler
{
	protected function canActionContent(Entity $content, &$error = null)
	{
		/** @var $content \xenMade\LD\Entity\Link */
		return $content->canApproveUnapprove($error);
	}

	public function getEntityWith()
	{
		return ['Category', 'Category.Permissions|' . \XF::visitor()->permission_combination_id, 'User'];
	}

	public function actionApprove(\xenMade\LD\Entity\Link $link)
	{
		/** @var \xenMade\LD\Service\Link\Approve $approver */
		$approver = \XF::service('xenMade\LD:Link\Approve', $link);
		$approver->setNotifyRunTime(1);
		$approver->approve();
	}

	public function actionDelete(\xenMade\LD\Entity\Link $link)
	{
		$this->quickUpdate($link, 'state', 'deleted');
	}
}