<?php

namespace xenMade\LD\Entity;

use XF\Entity\AbstractFieldMap;
use XF\Mvc\Entity\Structure;

class CategoryField extends AbstractFieldMap
{
	public static function getContainerKey()
	{
		return 'category_id';
	}

	public static function getStructure(Structure $structure)
	{
		self::setupDefaultStructure(
		    $structure,
            'xf_xenmade_ld_category_field',
            'xenMade\LD:CategoryField',
            'xenMade\LD:LinkField'
        );

		$structure->relations['Category'] = [
			'entity' => 'xenMade\LD:Category',
			'type' => self::TO_ONE,
			'conditions' => 'category_id',
			'primary' => true
		];

		return $structure;
	}
}