<?php

namespace xenMade\LD\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class CategoryUpgrade extends Entity
{
    public static function getContainerKey()
    {
        return 'category_id';
    }

    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_xenmade_ld_category_upgrade';
        $structure->shortName = 'xenMade\LD:CategoryUpgrade';
        $structure->primaryKey = ['category_id', 'upgrade_id'];

        $structure->columns = [
            'category_id' => ['type' => self::UINT, 'required' => true],
            'upgrade_id' => ['type' => self::UINT, 'required' => true]
        ];

        $structure->getters = [];

        $structure->relations = [
            'Upgrade' => [
                'entity' => 'xenMade\LD:LinkUpgrade',
                'type' => self::TO_ONE,
                'conditions' => 'upgrade_id',
                'primary' => true,
            ]
        ];

        return $structure;
    }
}