<?php

namespace xenMade\LD\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class CategoryWatch extends Entity
{
	public static function getStructure(Structure $structure)
	{
		$structure->table = 'xf_xenmade_ld_category_watch';
		$structure->shortName = 'xenMade\LD:CategoryWatch';
		$structure->primaryKey = ['category_id', 'user_id'];

		$structure->columns = [
			'user_id' => ['type' => self::UINT, 'required' => true],
			'category_id' => ['type' => self::UINT, 'required' => true],
			'notify_on' => ['type' => self::STR, 'default' => '', 'allowedValues' => ['', 'add']],
			'send_alert' => ['type' => self::BOOL, 'default' => false],
			'send_email' => ['type' => self::BOOL, 'default' => false],
			'include_children' => ['type' => self::BOOL, 'default' => false]
		];

		$structure->getters = [];

		$structure->relations = [
			'Category' => [
				'entity' => 'xenMade\LD:Category',
				'type' => self::TO_ONE,
				'conditions' => 'category_id',
				'primary' => true
			],

			'User' => [
				'entity' => 'XF:User',
				'type' => self::TO_ONE,
				'conditions' => 'user_id',
				'primary' => true
			],
		];

		return $structure;
	}
}