<?php

namespace xenMade\LD\Entity;

use XF\Entity\AbstractField;
use XF\Mvc\Entity\Structure;

class LinkField extends AbstractField
{
	protected function getClassIdentifier()
	{
		return 'xenMade\LD:LinkField';
	}

	protected static function getPhrasePrefix()
	{
		return 'ld_link_field';
	}

	protected function _postDelete()
	{
		/** @var \xenMade\LD\Repository\CategoryField $repo */
		$repo = $this->repository('xenMade\LD:CategoryField');
		$repo->removeFieldAssociations($this);

		$this->db()->delete('xf_xenmade_ld_link_field_value', 'field_id = ?', $this->field_id);

		parent::_postDelete();
	}

	public static function getStructure(Structure $structure)
	{
		self::setupDefaultStructure(
			$structure,
			'xf_xenmade_ld_link_field',
			'xenMade\LD:LinkField',
			[
				'groups' => ['above_main', 'above_info', 'below_info']
			]
		);

		$structure->relations['CategoryFields'] = [
			'entity' => 'xenMade\LD:CategoryField',
				'type' => self::TO_MANY,
				'conditions' => 'field_id'
		];

		return $structure;
	}
}