<?php

namespace xenMade\LD\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class LinkFieldValue extends Entity
{
	public static function getStructure(Structure $structure)
	{
		$structure->table = 'xf_xenmade_ld_link_field_value';
		$structure->shortName = 'xenMade\LD:LinkFieldValue';
		$structure->primaryKey = ['link_id', 'field_id'];
		$structure->columns = [
			'link_id' => ['type' => self::UINT, 'required' => true],
            'field_id' => ['type' => self::STR, 'maxLength' => 25,
                'match' => 'alphanumeric'
            ],
			'field_value' => ['type' => self::STR, 'default' => '']
		];

		$structure->getters = [];
		$structure->relations = [];

		return $structure;
	}
}