<?php

namespace xenMade\LD\Entity;

use XF\Entity\AbstractPrefix;
use XF\Mvc\Entity\Structure;

class LinkPrefix extends AbstractPrefix
{
	protected function getClassIdentifier()
	{
		return 'xenMade\LD:LinkPrefix';
	}

	protected static function getContentType()
	{
		return 'ld_link';
	}

    public static function getStructure(Structure $structure)
    {
        self::setupDefaultStructure($structure, 'xf_xenmade_ld_link_prefix', 'xenMade\LD:LinkPrefix');

        $structure->getters['category_ids'] = true;

        $structure->relations['CategoryPrefixes'] = [
            'entity' => 'xenMade\LD:CategoryPrefix',
            'type' => self::TO_MANY,
            'conditions' => 'prefix_id'
        ];

        return $structure;
    }

	public function getCategoryIds()
	{
		if (!$this->prefix_id)
		{
			return [];
		}

		return $this->db()->fetchAllColumn("
			SELECT category_id
			FROM xf_xenmade_ld_category_prefix
			WHERE prefix_id = ?
		", $this->prefix_id);
	}

	protected function _postDelete()
	{
		parent::_postDelete();

		$this->repository('xenMade\LD:CategoryPrefix')->removePrefixAssociations($this);
	}
}