<?php

namespace xenMade\LD\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class LinkUpgradeExpired extends Entity
{
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_xenmade_ld_link_upgrade_expired';
        $structure->shortName = 'xenMade\LD:CategoryUpgradeExpired';
        $structure->primaryKey = 'upgrade_record_id';

        $structure->columns = [
            'upgrade_record_id' => ['type' => self::UINT, 'nullable' => true],
            'link_id' => ['type' => self::UINT, 'required' => true],
            'purchase_request_key' => ['type' => self::STR, 'maxLength' => 32, 'nullable' => true],
            'upgrade_id' => ['type' => self::UINT, 'required' => true],
            'extra' => ['type' => self::SERIALIZED_ARRAY, 'default' => []],
            'start_date' => ['type' => self::UINT, 'default' => 0],
            'end_date' => ['type' => self::UINT, 'default' => 0],
            'original_end_date' => ['type' => self::UINT, 'default' => 0],
        ];

        $structure->getters = [];

        $structure->relations = [
            'Link' => [
                'entity' => 'xenMade\LD:Link',
                'type' => self::TO_ONE,
                'conditions' => 'link_id'
            ],
            'Upgrade' => [
                'entity' => 'xenMade\LD:LinkUpgrade',
                'type' => self::TO_ONE,
                'conditions' => 'upgrade_id',
                'primary' => true
            ],
            'PurchaseRequest' => [
                'entity' => 'XF:PurchaseRequest',
                'type' => self::TO_ONE,
                'conditions' => [
                    ['request_key', '=', '$purchase_request_key']
                ]
            ]
        ];

        return $structure;
    }
}