<?php

namespace xenMade\LD\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class LinkWatch extends Entity
{
	public static function getStructure(Structure $structure)
	{
		$structure->table = 'xf_xenmade_ld_link_watch';
		$structure->shortName = 'xenMade\LD:LinkWatch';
		$structure->primaryKey = ['link_id', 'user_id'];
		$structure->columns = [
			'user_id' => ['type' => self::UINT, 'required' => true],
			'link_id' => ['type' => self::UINT, 'required' => true],
			'email_subscribe' => ['type' => self::BOOL, 'default' => false]
		];

		$structure->getters = [];

		$structure->relations = [
			'Link' => [
				'entity' => 'xenMade\LD:Link',
				'type' => self::TO_ONE,
				'conditions' => 'link_id',
				'primary' => true
			],
			'User' => [
				'entity' => 'XF:User',
				'type' => self::TO_ONE,
				'conditions' => 'user_id',
				'primary' => true
			],
		];

		return $structure;
	}
}