<?php

namespace xenMade\LD\Finder;

use XF\Mvc\Entity\Finder;

class LinkRating extends Finder
{
	public function inLink(\xenMade\LD\Entity\Link $link, array $limits = [])
	{
		$limits = array_replace([
			'visibility' => true
		], $limits);

		$this->where('link_id', $link->link_id);

		if ($limits['visibility'])
		{
			$this->applyVisibilityChecksInLink($link);
		}

		return $this;
	}

	public function applyVisibilityChecksInLink(\xenMade\LD\Entity\Link $link)
	{
		$conditions = [];
		$viewableStates = ['visible'];

        if (\XF::visitor()->hasPermission('ld_link', 'viewDeleted'))
        {
            $viewableStates[] = 'deleted';

            $this->with('DeletionLog');
        }

		$conditions[] = ['rating_state', $viewableStates];

		$this->whereOr($conditions);

		return $this;
	}

	public function forFullView()
	{
		$this->with('User');

		return $this;
	}
}