<?php

namespace xenMade\LD\Import\Data;

use XF\Import\Data\AbstractEmulatedData;

class LinkPrefix extends AbstractEmulatedData
{
    protected $title = '';

    protected $categoryIds = [];

    public function getImportType()
    {
        return 'ld_link_prefix';
    }

    public function getEntityShortName()
    {
        return 'xenMade\LD:LinkPrefix';
    }

    public function setTitle($title)
    {
        $this->title = $title;
    }

    public function setCategories(array $categoryIds)
    {
        $this->categoryIds = $categoryIds;
    }

    protected function postSave($oldId, $newId)
    {
        /** @var \xenMade\LD\Entity\LinkPrefix $prefix */
        $prefix = $this->em()->find('xenMade\LD:LinkPrefix', $newId);
        
        if ($prefix)
        {
            $this->insertMasterPhrase($prefix->getPhraseName(), $this->title, [], true);

            $this->em()->detachEntity($prefix);
        }

        if ($this->categoryIds)
        {
            $insert = [];
            foreach ($this->categoryIds AS $categoryId)
            {
                $insert[] = [
                    'category_id' => $categoryId,
                    'prefix_id' => $newId
                ];
            }

            $this->db()->insertBulk('xf_xenmade_ld_category_prefix', $insert, false, false, 'IGNORE');
        }

        /** @var \xenMade\LD\Repository\LinkPrefix $repo */
        $repo = $this->repository('xenMade\LD:LinkPrefix');

        \XF::runOnce('xenMadeLDRebuildLinkPrefixImport', function() use ($repo)
        {
            $repo->rebuildPrefixMaterializedOrder();
            $repo->rebuildPrefixCache();
        });
    }
}