<?php

namespace xenMade\LD\Import\Importer;

use XF\Import\Importer\AbstractImporter;

abstract class AbstractLDImporter extends AbstractImporter
{
	public function canRetainIds()
	{
		$db = $this->app->db();
		
		$maxLinks = $db->fetchOne("SELECT MAX(link_id) FROM xf_xenmade_ld_link");
		if ($maxLinks)
		{
			return false;
		}
		
		$maxCategoryId = $db->fetchOne("SELECT MAX(category_id) FROM xf_xenmade_ld_category");
		if ($maxCategoryId > 1)
		{
			return false;
		}

		return true;
	}

	public function resetDataForRetainIds()
	{
		$category = $this->em()->find('xenMade\LD:Category', 1);

		if ($category)
		{
			$category->delete();
		}
	}

	public function getFinalizeJobs(array $stepsRun)
	{
		return [
			'XF:User',
			'XF:PermissionRebuild',
			'xenMade\LD:Category',
			'xenMade\LD:Link',
			'xenMade\LD:UserCount',
		];
	}
}