<?php

namespace xenMade\LD\InlineMod;

use XF\InlineMod\AbstractHandler;
use XF\Mvc\Entity\Entity;

class Link extends AbstractHandler
{
	public function getPossibleActions()
	{
		$actions = [];

		$actions['delete'] = $this->getActionHandler('xenMade\LD:Link\Delete');

		$actions['undelete'] = $this->getSimpleActionHandler(\XF::phrase('ld_undelete_links'), 'canUndelete',
			function(Entity $link)
			{
				/** @var \xenMade\LD\Entity\Link $link */
				if ($link->state == 'deleted')
				{
                    $link->state = 'visible';
                    $link->save();
				}
			}
		);



		$actions['approve'] = $this->getSimpleActionHandler(\XF::phrase('ld_approve_links'), 'canApproveUnapprove',
			function(Entity $link)
			{
				/** @var \xenMade\LD\Entity\Link $link */
				if ($link->state == 'moderated')
				{
					/** @var \xenMade\LD\Service\Link\Approve $approver */
					$approver = \XF::service('xenMade\LD:Link\Approve', $link);
					$approver->setNotifyRunTime(1);
					$approver->approve();
				}
			}
		);

		$actions['unapprove'] = $this->getSimpleActionHandler(\XF::phrase('ld_unapprove_links'), 'canApproveUnapprove',
			function(Entity $link)
			{
				/** @var \xenMade\LD\Entity\Link $link */
				if ($link->state == 'visible')
				{
                    $link->state = 'moderated';
                    $link->save();
				}
			}
		);



        $actions['makevip'] = $this->getSimpleActionHandler(\XF::phrase('ld_make_vip_links'), 'canApproveUnapprove',
            function(Entity $link)
            {
                /** @var \xenMade\LD\Entity\Link $link */
                if (!$link->is_vip)
                {
                    $link->is_vip = true;
                    $link->save();
                }
            }
        );

        $actions['unmakevip'] = $this->getSimpleActionHandler(\XF::phrase('ld_unmake_vip_links'), 'canApproveUnapprove',
            function(Entity $link)
            {
                /** @var \xenMade\LD\Entity\Link $link */
                if ($link->is_vip)
                {
                    $link->is_vip = false;
                    $link->save();
                }
            }
        );



		$actions['reassign'] = $this->getActionHandler('xenMade\LD:Link\Reassign');
		$actions['move'] = $this->getActionHandler('xenMade\LD:Link\Move');
		$actions['apply_prefix'] = $this->getActionHandler('xenMade\LD:Link\ApplyPrefix');

		return $actions;
	}

	public function getEntityWith()
	{
		$visitor = \XF::visitor();

		return ['Category', 'Category.Permissions|' . $visitor->permission_combination_id];
	}
}