<?php

namespace xenMade\LD\InlineMod;

use XF\InlineMod\AbstractHandler;
use XF\Mvc\Entity\Entity;

class LinkComment extends AbstractHandler
{
	public function getPossibleActions()
	{
		$actions = [];

		$actions['delete'] = $this->getActionHandler('xenMade\LD:LinkComment\Delete');

		$actions['undelete'] = $this->getSimpleActionHandler(
			\XF::phrase('ld_undelete_comments'),
			'canUndelete',
			function(Entity $entity)
			{
				/** @var \xenMade\LD\Entity\LinkComment $entity */
				if ($entity->message_state == 'deleted')
				{
					$entity->message_state = 'visible';
					$entity->save();
				}
			}
		);

		$actions['approve'] = $this->getSimpleActionHandler(
			\XF::phrase('ld_approve_comments'),
			'canApproveUnapprove',
			function(Entity $entity)
			{
				/** @var \xenMade\LD\Entity\LinkComment $entity */
				if ($entity->message_state == 'moderated')
				{
					/** @var \xenMade\LD\Service\LinkComment\Approver $approver */
					$approver = \XF::service('xenMade\LD:LinkComment\Approver', $entity);
					$approver->approve();
				}
			}
		);

		$actions['unapprove'] = $this->getSimpleActionHandler(
			\XF::phrase('ld_unapprove_comments'),
			'canApproveUnapprove',
			function(Entity $entity)
			{
				/** @var \xenMade\LD\Entity\LinkComment $entity */
				if ($entity->message_state == 'visible')
				{
					$entity->message_state = 'moderated';
					$entity->save();
				}
			}
		);

		return $actions;
	}

	public function getEntityWith()
	{
		return ['Link'];
	}
}