<?php

namespace xenMade\LD\Job;

use XF\Job\AbstractRebuildJob;

class Category extends AbstractRebuildJob
{
	protected function getNextIds($start, $batch)
	{
		$db = $this->app->db();

		return $db->fetchAllColumn($db->limit(
			"
				SELECT category_id
				FROM xf_xenmade_ld_category
				WHERE category_id > ?
				ORDER BY category_id
			", $batch
		), $start);
	}

	protected function rebuildById($id)
	{
		/** @var \xenMade\LD\Entity\Category $category */
		$category = $this->app->em()->find('xenMade\LD:Category', $id);
		if ($category)
		{
			$category->rebuildCounters();
			$category->save();
		}
	}

	protected function getStatusType()
	{
		return \XF::phrase('ld_link_categories');
	}
}