<?php

namespace xenMade\LD\Job;

use XF\Job\AbstractRebuildJob;

class Link extends AbstractRebuildJob
{
	protected function getNextIds($start, $batch)
	{
		$db = $this->app->db();

		return $db->fetchAllColumn($db->limit(
			"
				SELECT link_id
				FROM xf_xenmade_ld_link
				WHERE link_id > ?
				ORDER BY link_id
			", $batch
		), $start);
	}

	protected function rebuildById($id)
	{
		/** @var \xenMade\LD\Entity\Link $link */
        $link = $this->app->em()->find('xenMade\LD:Link', $id);

        if ($link)
		{
            $link->rebuildCounters();
            $link->save();
		}
	}

	protected function getStatusType()
	{
		return \XF::phrase('ld_links');
	}
}