<?php

namespace xenMade\LD\Job;

use XF\Job\AbstractRebuildJob;

class LinkThumbnail extends AbstractRebuildJob
{
	protected function getNextIds($start, $batch)
	{
		$db = $this->app->db();

        return $db->fetchAllColumn($db->limit(
            "
				SELECT link_id
				FROM xf_xenmade_ld_link
				WHERE link_id > ?
				ORDER BY image_date ASC
			", $batch
        ), $start);
	}

	protected function rebuildById($id)
	{
        /** @var \xenMade\LD\Entity\Link $link */
        $link = $this->app->em()->find('xenMade\LD:Link', $id);

        if ($link)
        {
            /** @var \xenMade\LD\Thumbnail\AbstractThumbnail $ldThumbnail */
            $ldThumbnail = \XF::app()->container('ldThumbnail');
            $ldThumbnail->setLink($link);

            if($ldThumbnail->getThumbnail())
            {
                $link->fastUpdate([
                        'image_date' => \XF::$time + (86400 * 30)
                    ]
                );
            }
        }
	}

	protected function getStatusType()
	{
		return \XF::phrase('ld_thumbnailer');
	}
}