<?php

namespace xenMade\LD\Job;

use \XF\Mvc\Entity\Entity;
use XF\Job\AbstractJob;

class Status extends AbstractJob
{
    protected $defaultData = [
        'fails' => false,
    ];

    public function run($maxRunTime)
	{
		$startTime = microtime(true);

		$linkFinder = $this->app->finder('xenMade\LD:Link');

		$linkFinder
            ->order('status_check', 'ASC')
            ->limit(100);

		if($this->data['fails'])
        {
            $linkFinder->where('status_fails', '>', 0);
        }

        $links = $linkFinder->fetch();

		foreach ($links AS $link)
		{
		    /** @var \xenMade\LD\Service\Link\Status $status */
            $status = $this->app->service('xenMade\LD:Link\Status', $link);

            $httpCode = $status->statusChecker();


            if($httpCode == 200)
            {
                $link->set('status_check', \XF::$time + (86400 * 7));
                $link->set('status_fails', 0);
            }
            else
            {
                $link->set('status_fails', $link->status_fails + 1);
                $link->set('status_check', \XF::$time + 3600);
            }

            if($link->status_fails == 3)
            {
                $link->set('state', 'moderated');
            }

            $link->save(false);

            if (microtime(true) - $startTime >= $maxRunTime)
            {
                break;
            }
		}

		return $this->complete();
	}

    public function getStatusMessage()
	{
		return \XF::phrase('ld_status_checker');
	}

	public function canCancel()
	{
		return;
	}

	public function canTriggerByChoice()
	{
		return;
	}
}