<?php

namespace xenMade\LD\Job;

use \XF\Mvc\Entity\Entity;
use XF\Job\AbstractJob;

class Thumbnail extends AbstractJob
{
    public function run($maxRunTime)
	{
		$startTime = microtime(true);

		$linkFinder = $this->app->finder('xenMade\LD:Link');

		$links = $linkFinder
            ->where('image_date', '<=', \XF::$time)
            ->order('image_date', 'ASC')
            ->limit(50)
            ->fetch();

		foreach ($links AS $link)
		{
            /** @var \xenMade\LD\Thumbnail\AbstractThumbnail $ldThumbnail */
            $ldThumbnail = \XF::app()->container('ldThumbnail');
            $ldThumbnail->setLink($link);

            if($ldThumbnail->getThumbnail())
            {
                $link->fastUpdate([
                        'image_date' => \XF::$time + (86400 * 30)
                    ]
                );
            }

            if (microtime(true) - $startTime >= $maxRunTime)
            {
                break;
            }
		}

		return $this->complete();
	}

    public function getStatusMessage()
	{
		return \XF::phrase('ld_thumbnailer');
	}

	public function canCancel()
	{
		return;
	}

	public function canTriggerByChoice()
	{
		return;
	}
}