<?php

namespace xenMade\LD\Job;

use XF\Job\AbstractRebuildJob;

class UserCount extends AbstractRebuildJob
{
	protected function getNextIds($start, $batch)
	{
		$db = $this->app->db();

		return $db->fetchAllColumn($db->limit(
			"
				SELECT user_id
				FROM xf_user
				WHERE user_id > ?
				ORDER BY user_id
			", $batch
		), $start);
	}

	protected function rebuildById($id)
	{
		/** @var \xenMade\LD\Repository\Link $linkRepo */
        $linkRepo = $this->app->repository('xenMade\LD:Link');
		$count = $linkRepo->getUserCount($id);

		$this->app->db()->update('xf_user', ['ld_link_count' => $count], 'user_id = ?', $id);
	}

	protected function getStatusType()
	{
		return \XF::phrase('ld_link_counts');
	}
}