<?php

namespace xenMade\LD\Notifier\Link;

class CategoryWatch extends AbstractWatch
{
	protected function getApplicableActionTypes()
	{
		return ['add'];
	}

	public function getDefaultWatchNotifyData()
	{
		$category = $this->link->Category;

		$checkCategories = array_keys($category->breadcrumb_data);
		$checkCategories[] = $category->category_id;

		$finder = $this->app()->finder('xenMade\LD:CategoryWatch');

		$finder->where('category_id', $checkCategories)
			->where('User.user_state', '=', 'valid')
			->where('User.is_banned', '=', 0)
			->whereOr(
				['include_children', '>', 0],
				['category_id', $category->category_id]
			)
			->whereOr(
				['send_alert', '>', 0],
				['send_email', '>', 0]
			);

        $finder->where('notify_on', 'add');

		$activeLimit = $this->app()->options()->watchAlertActiveOnly;
		if (!empty($activeLimit['enabled']))
		{
			$finder->where('User.last_activity', '>=', \XF::$time - 86400 * $activeLimit['days']);
		}

		$notifyData = [];
		foreach ($finder->fetchColumns(['user_id', 'send_alert', 'send_email']) AS $watch)
		{
			$notifyData[$watch['user_id']] = [
				'alert' => (bool)$watch['send_alert'],
				'email' => (bool)$watch['send_email']
			];
		}

		return $notifyData;
	}

	protected function getWatchEmailTemplateName()
	{
		return 'ld_watched_category_add';
	}
}