<?php

namespace xenMade\LD\Permission;

use XF\Mvc\Entity\Entity;
use XF\Permission\TreeContentPermissions;

class CategoryPermissions extends TreeContentPermissions
{
	public function getContentType()
	{
		return 'ld_category';
	}

	public function getAnalysisTypeTitle()
	{
		return \XF::phrase('ld_link_category_permissions');
	}

	public function getContentTitle(Entity $entity)
	{
		return $entity->title;
	}

	public function isValidPermission(\XF\Entity\Permission $permission)
	{
		return ($permission->permission_group_id == 'ld_link');
	}

	public function getContentTree()
	{
		/** @var \xenMade\LD\Repository\Category $categoryRepo */
		$categoryRepo = $this->builder->em()->getRepository('xenMade\LD:Category');
		return $categoryRepo->createCategoryTree($categoryRepo->findCategoryList()->fetch());
	}

	protected function getFinalPerms($contentId, array $calculated, array &$childPerms)
	{
		if (!isset($calculated['ld_link']))
		{
			$calculated['ld_link'] = [];
		}

		$final = $this->builder->finalizePermissionValues($calculated['ld_link']);

		if (empty($final['view']))
		{
			$childPerms['ld_link']['view'] = 'deny';
		}

		return $final;
	}

	protected function getFinalAnalysisPerms($contentId, array $calculated, array &$childPerms)
	{
		$final = $this->builder->finalizePermissionValues($calculated);

		if (empty($final['ld_link']['view']))
		{
			$childPerms['ld_link']['view'] = 'deny';
		}

		return $final;
	}
}