<?php

namespace xenMade\LD\Repository;

use XF\Repository\AbstractCategoryTree;

class Category extends AbstractCategoryTree
{
	protected function getClassName()
	{
		return 'xenMade\LD:Category';
	}

	public function mergeCategoryListExtras(array $extras, array $childExtras)
	{
		$output = array_merge([
			'childCount' => 0,
			'link_count' => 0,
			'last_update' => 0,
			'last_link_title' => '',
			'last_link_id' => 0
		], $extras);

		foreach ($childExtras AS $child)
		{
			if (!empty($child['link_count']))
			{
				$output['link_count'] += $child['link_count'];
			}

			if (!empty($child['last_update']) && $child['last_update'] > $output['last_update'])
			{
				$output['last_update'] = $child['last_update'];
				$output['last_link_title'] = $child['last_link_title'];
				$output['last_link_id'] = $child['last_link_id'];
			}

			$output['childCount'] += 1 + (!empty($child['childCount']) ? $child['childCount'] : 0);
		}

		return $output;
	}
}