<?php

namespace xenMade\LD\Repository;

class CategoryUpgrade extends AbstractUpgradeMap
{
	protected function getMapEntityIdentifier()
	{
		return 'xenMade\LD:CategoryUpgrade';
	}

	protected function getAssociationsForUpgrade(\xenMade\LD\Entity\LinkUpgrade $upgrade)
	{
		return $upgrade->getRelation('CategoryUpgrades');
	}

	protected function updateAssociationCache(array $cache)
	{
		$categoryIds = array_keys($cache);
		$categories = $this->em->findByIds('xenMade\LD:Category', $categoryIds);

		foreach ($categories AS $category)
		{
			/** @var \xenMade\LD\Entity\Category $category */
			$category->field_cache = $cache[$category->category_id];
			$category->saveIfChanged();
		}
	}
}