<?php

namespace xenMade\LD\Repository;

use XF\Repository\AbstractPrefix;

class LinkPrefix extends AbstractPrefix
{
	protected function getRegistryKey()
	{
		return 'ldPrefixes';
	}

	protected function getClassIdentifier()
	{
		return 'xenMade\LD:LinkPrefix';
	}

	public function getVisiblePrefixListData()
	{
		if (!method_exists($this, '_getVisiblePrefixListData'))
		{
			return $this->getPrefixListData();
		}

		$prefixMap = $this->finder('xenMade\LD:CategoryPrefix')
			->with('Category', true)
			->with('Category.Permissions|' . \XF::visitor()->permission_combination_id)
			->fetch();

		$isVisibleClosure = function(\xenMade\LD\Entity\LinkPrefix $prefix) use ($prefixMap)
		{
			$isVisible = false;

			foreach ($prefixMap AS $categoryPrefix)
			{
				/** @var \xenMade\LD\Entity\CategoryPrefix $categoryPrefix */
				if ($prefix->prefix_id == $categoryPrefix->prefix_id)
				{
					$isVisible = $categoryPrefix->Category->canView();
				}
			}

			return $isVisible;
		};
		return $this->_getVisiblePrefixListData($isVisibleClosure);
	}
}