<?php

namespace xenMade\LD\Service\Link;

class Approve extends \XF\Service\AbstractService
{
	protected $link;

	protected $notifyRunTime = 3;

	public function __construct(\XF\App $app, \xenMade\LD\Entity\Link $link)
	{
		parent::__construct($app);
		$this->link = $link;
	}

	public function getLink()
	{
		return $this->link;
	}

	public function setNotifyRunTime($time)
	{
		$this->notifyRunTime = $time;
	}

	public function approve()
	{
		if ($this->link->state == 'moderated')
		{
			$this->link->state = 'visible';
			$this->link->status_fails = 0;
			$this->link->save();

			$this->onApprove();
			return true;
		}
		else
		{
			return false;
		}
	}

	protected function onApprove()
	{
        /** @var \xenMade\LD\Service\Link\Notify $notifier */
        $notifier = $this->service('xenMade\LD:Link\Notify', $this->link, 'add');
        $notifier->notifyAndEnqueue($this->notifyRunTime);
	}
}