<?php

namespace xenMade\LD\Service\Link;

class Backlink extends \XF\Service\AbstractService
{
	protected $link;

	public $jobChecker = false;

	public function __construct(\XF\App $app, \xenMade\LD\Entity\Link $link)
	{
		parent::__construct($app);

		$this->link = $link;
	}

	public function backlinkChecker()
	{
	    if(!empty($this->link->Category->backlink))
        {
            $returnData = $this->getCurl();

            if($returnData)
            {
                list($html, $statusCode) = $returnData;

                if($statusCode !== 200)
                {
                    if($this->jobChecker)
                    {
                        return false;
                    }

                    return $this->link->error(\XF::phraseDeferred('ld_backlink_not_found'), 'url');
                }

                if(!preg_match('#' . preg_quote($this->link->Category->backlink, '#') . '#i', $html))
                {
                    if($this->jobChecker)
                    {
                        return false;
                    }

                    return $this->link->error(\XF::phraseDeferred('ld_backlink_not_found'), 'url');
                }
            }
        }

	    return true;
    }

    protected function getCurl()
    {
        $html = '';
        $statusCode = 0;

        try
        {
            $url = $this->link->url;

            if($this->link->Category->backlink_location)
            {
                $url = $this->link->backlink_location;
            }

            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($ch, CURLOPT_TIMEOUT, 10);

            curl_setopt($ch, CURLOPT_VERBOSE, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_AUTOREFERER, true);
            curl_setopt($ch, CURLOPT_REFERER, $this->link->url);
            curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:42.0) Gecko/20100101 Firefox/42.0');
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_NOBODY, false);

            $html = curl_exec($ch);
            $statusCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

            curl_close($ch);
        }
        catch (\Exception $e)
        {
        }

        return [
            $html,
            $statusCode,
        ];
    }
}