<?php

namespace xenMade\LD\Service\Link;

class Reassign extends \XF\Service\AbstractService
{
	protected $link;

	protected $alert = false;
	protected $alertReason = '';

	public function __construct(\XF\App $app, \xenMade\LD\Entity\Link $link)
	{
		parent::__construct($app);
		$this->link = $link;
	}

	public function getLink()
	{
		return $this->link;
	}

	public function setSendAlert($alert, $reason = null)
	{
		$this->alert = (bool)$alert;
		if ($reason !== null)
		{
			$this->alertReason = $reason;
		}
	}

	public function reassignTo(\XF\Entity\User $newUser)
	{
        $link = $this->link;
		$reassigned = ($link->user_id != $newUser->user_id);

        $link->user_id = $newUser->user_id;
        $link->username = $newUser->username;
        $link->save();

		if ($link->user_id && $reassigned && $link->isVisible() && $this->alert)
		{
            /** @var \xenMade\LD\Repository\Link $linkRepo */
            $linkRepo = $this->repository('xenMade\LD:Link');

			if (\XF::visitor()->user_id != $link->user_id)
			{
                $linkRepo->sendModeratorActionAlert($this->link, 'reassign_from', $this->alertReason, ['to' => $newUser->username], $link->User);
			}

			if (\XF::visitor()->user_id != $newUser->user_id)
			{
                $linkRepo->sendModeratorActionAlert($this->link, 'reassign_to', $this->alertReason, [], $newUser);
			}
		}

		return $reassigned;
	}
}