<?php

namespace xenMade\LD\Service\LinkComment;

use xenMade\LD\Entity\LinkComment;

class Approver extends \XF\Service\AbstractService
{
	protected $linkComment;

	public function __construct(\XF\App $app, LinkComment $linkComment)
	{
		parent::__construct($app);
		$this->linkComment = $linkComment;
	}

	public function getLinkComment()
	{
		return $this->linkComment;
	}

	public function approve()
	{
		if ($this->linkComment->message_state == 'moderated')
		{
			$this->linkComment->message_state = 'visible';
			$this->linkComment->save();

			$this->onApprove();
			return true;
		}
		else
		{
			return false;
		}
	}

	protected function onApprove()
	{
		/** @var \xenMade\LD\Service\LinkComment\Notifier $notifier */
		$notifier = $this->service('xenMade\LD:LinkComment\Notifier', $this->linkComment);
		$notifier->notify();
	}
}