<?php

namespace xenMade\LD\Service\LinkComment;

use xenMade\LD\Entity\LinkComment;

class Deleter extends \XF\Service\AbstractService
{
	protected $linkComment;

	protected $link;

	protected $user;

	protected $alert = false;
	protected $alertReason = '';

	public function __construct(\XF\App $app, LinkComment $linkComment)
	{
		parent::__construct($app);
		$this->linkComment = $linkComment;
		$this->link = $linkComment->Link;
		$this->user = \XF::visitor();
	}

    public function getLinkComment()
	{
		return $this->linkComment;
	}

	public function getLink()
	{
		return $this->link;
	}

	public function setSendAlert($alert, $reason = null)
	{
		$this->alert = (bool)$alert;
		if ($reason !== null)
		{
			$this->alertReason = $reason;
		}
	}

	public function delete($type, $reason = '')
	{
		$linkComment = $this->linkComment;
		$wasVisible = ($linkComment->message_state == 'visible');

		if ($type == 'soft')
		{
			$result = $linkComment->softDelete($reason, $this->user);
		}
		else
		{
			$result = $linkComment->delete();
		}

		if ($result && $wasVisible && $this->alert && $linkComment->user_id != $this->user->user_id)
		{
			/** @var \xenMade\LD\Repository\LinkComment $linkCommentRepo */
            $linkCommentRepo = $this->repository('xenMade\LD:LinkComment');
            $linkCommentRepo->sendModeratorActionAlert($linkComment, 'delete', $this->alertReason);
		}

		return $result;
	}

	public function undelete()
	{
		$linkComment = $this->linkComment;
        $result = $linkComment->softundelete();
		return $result;
	}
}