<?php

namespace xenMade\LD\Service\LinkRating;

use xenMade\LD\Entity\LinkRating;

class Deleter extends \XF\Service\AbstractService
{
	protected $linkRating;

	protected $link;

	protected $user;

	protected $alert = false;
	protected $alertReason = '';

	public function __construct(\XF\App $app, LinkRating $linkRating)
	{
		parent::__construct($app);
		$this->linkRating = $linkRating;
		$this->link = $linkRating->Link;
		$this->user = \XF::visitor();
	}

    public function getLinkRating()
	{
		return $this->linkRating;
	}

	public function getLink()
	{
		return $this->link;
	}

	public function setSendAlert($alert, $reason = null)
	{
		$this->alert = (bool)$alert;
		if ($reason !== null)
		{
			$this->alertReason = $reason;
		}
	}

	public function delete($type, $reason = '')
	{
		$linkRating = $this->linkRating;
		$wasVisible = ($linkRating->rating_state == 'visible');

		if ($type == 'soft')
		{
			$result = $linkRating->softDelete($reason, $this->user);
		}
		else
		{
			$result = $linkRating->delete();
		}

		if ($result && $wasVisible && $this->alert && $linkRating->user_id != $this->user->user_id)
		{
			/** @var \xenMade\LD\Repository\LinkRating $linkRatingRepo */
            $linkRatingRepo = $this->repository('xenMade\LD:LinkRating');
            $linkRatingRepo->sendModeratorActionAlert($linkRating, 'delete', $this->alertReason);
		}

		return $result;
	}

	public function undelete()
	{
		$linkRating = $this->linkRating;
        $result = $linkRating->softundelete();
		return $result;
	}
}