<?php

namespace xenMade\LD\Sitemap;

use XF\Sitemap\AbstractHandler;
use XF\Sitemap\Entry;

class Link extends AbstractHandler
{
	public function getRecords($start)
	{
		$user = \XF::visitor();

		$ids = $this->getIds('xf_xenmade_ld_link', 'link_id', $start);

		$finder = $this->app->finder('xenMade\LD:Link');
        $links = $finder
			->where('link_id', $ids)
			->with(['Category', 'Category.Permissions|' . $user->permission_combination_id])
			->order('link_id')
			->fetch();

		return $links;
	}

	public function getEntry($record)
	{
		$url = $this->app->router('public')->buildLink('canonical:link-directory', $record);
		return Entry::create($url, ['lastmod' => $record->last_update]);
	}

	public function isIncluded($record)
	{
		/** @var $record \xenMade\LD\Entity\Link */
		if (!$record->isVisible())
		{
			return false;
		}
		return $record->canView();
	}
}