<?php

namespace xenMade\LD\Stats;

use XF\Stats\AbstractHandler;

class Link extends AbstractHandler
{
	public function getStatsTypes()
	{
		return [
			'link' => \XF::phrase('ld_links'),
			'link_rating' => \XF::phrase('ld_link_ratings')
		];
	}

	public function getData($start, $end)
	{
		$db = $this->db();

		$links = $db->fetchPairs(
			$this->getBasicDataQuery('xf_xenmade_ld_link', 'insert_date', 'state = ?'),
			[$start, $end, 'visible']
		);

		$linkRatings = $db->fetchPairs(
			$this->getBasicDataQuery('xf_xenmade_ld_link_rating', 'rating_date', 'rating_state = ?'),
			[$start, $end, 'visible']
		);

		return [
			'link' => $links,
			'link_rating' => $linkRatings
		];
	}
}