<?php

namespace xenMade\LD\Thumbnail;

use function MongoDB\BSON\fromJSON;
use XF\Template\Templater;

class Google extends AbstractThumbnail
{
    public function form(Templater $templater)
    {
        return $templater->renderTemplate('public:ld_thumbnail_formlos');
    }

    public function getThumbnail()
    {
        try
        {
            $ch = curl_init('https://www.googleapis.com/pagespeedonline/v5/runPagespeed?rule=null&strategy=desktop&url=' . $this->link->url);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, \XF::options()->ldThumbTimeout);
            curl_setopt($ch, CURLOPT_TIMEOUT, \XF::options()->ldThumbTimeout);

            curl_setopt($ch, CURLOPT_VERBOSE, false);
            curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:42.0) Gecko/20100101 Firefox/42.0');
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_NOBODY, false);

            $html = curl_exec($ch);
            curl_close($ch);

            $responseJson = json_decode($html, true);

            if(!empty($responseJson['lighthouseResult']['audits']['final-screenshot']['details']['data']))
            {
                $data = $responseJson['lighthouseResult']['audits']['final-screenshot']['details']['data'];
                $data = str_replace('_', '/', $data);
                $data = str_replace('-', '+', $data);
                $base64img = str_replace('data:image/jpeg;base64,', '', $data);
                $data = base64_decode($base64img);

                $tmpPath = \XF\Util\File::getTempFile();
                file_put_contents($tmpPath, $data);

                $class = \XF::extendClass('XF\Http\Upload');
                $upload = new $class($tmpPath, 'ldThumbTmp.jpg');

                $upload->requireImage();

                if (!$upload->isValid($errors))
                {
                    $this->setError($errors);
                    return false;
                }

                $this->saveThumbnail($upload);
            }
        }
        catch (\Exception $e)
        {}

        return true;
    }
}