<?php

namespace xenMade\LD\Thumbnail;

use XF\Template\Templater;

class Upload extends AbstractThumbnail
{
    public function form(Templater $templater)
    {
        return $templater->renderTemplate('public:ld_thumbnail_upload');
    }

    public function getThumbnail()
    {
        /** @var \XF\Http\Upload $upload */
        $upload = $this->app->request->getFile('thumbnailUploader', false, false);

        if($upload)
        {
            $upload->requireImage();

            if (!$upload->isValid($errors))
            {
                $this->setError($errors);
                return false;
            }

            $this->saveThumbnail($upload);
        }

        return true;
    }
}