<?php

namespace xenMade\LD\Thumbnail;

use XF\Template\Templater;

class UploadGoogle extends AbstractThumbnail
{
    public function form(Templater $templater)
    {
        return $templater->renderTemplate('public:ld_thumbnail_upload_fallback_google');
    }

    public function getThumbnail()
    {
        /** @var \XF\Http\Upload $upload */
        $upload = $this->app->request->getFile('thumbnailUploader', false, false);

        if($upload)
        {
            $upload->requireImage();

            if (!$upload->isValid($errors))
            {
                $this->setError($errors);
                return false;
            }

            $this->saveThumbnail($upload);
        }
        else
        {
            $class = 'xenMade\LD\Thumbnail\Google';
            $class = \XF::app()->extendClass($class);
            $googe = new $class(\XF::app());

            $googe->setLink($this->getLink());
            $googe->getThumbnail();
            unset($googe);
        }

        return true;
    }
}