<?php

namespace xenMade\LD\XF\Entity;

use XF\Mvc\Entity\Structure;

class User extends XFCP_User
{
    public static function getStructure(Structure $structure)
    {
        $structure = parent::getStructure($structure);

        $structure->columns['ld_link_count'] = ['type' => self::UINT, 'default' => 0, 'changeLog' => false];

        return $structure;
    }

    public function hasLinkCategoryPermission($contentId, $permission)
    {
        return $this->PermissionSet->hasContentPermission('ld_category', $contentId, $permission);
    }

	public function canViewLinks(&$error = null)
	{
		return $this->hasPermission('ld_link', 'view');
	}

    public function canViewLinkRatings(&$error = null)
    {
        return $this->hasPermission('ld_link', 'viewRatings');
    }

	public function canAddLink(&$error = null)
	{
		return $this->hasPermission('ld_link', 'add');
	}

	public function canViewLinkComments(&$error = null)
	{
		return $this->hasPermission('ld_link_comment', 'view');
	}
}
if(false)
{
    class XFCP_User extends \XF\Entity\User {}
}